NAME

OpenAPI::Client::OpenAI::Path::images-edits - Documentation for the /images/edits path.

OPERATIONS

POST /images/edits

createImageEdit

$client->create_image_edit({
    body => { ... },
});

Creates an edited or extended image given one or more source images and a prompt. This endpoint supports GPT Image models (gpt-image-1.5, gpt-image-1 , gpt-image-1-mini , and chatgpt-image-latest ) and dall-e-2 .

You can call this endpoint with either:

- multipart/form-data : use binary uploads via image (and optional mask ). - application/json : use images (and optional mask ) as references with either image_url or file_id .

Note that JSON requests use images (array) instead of the multipart image field.

Request body

Content-Type: application/json

Example:

{
   "background" : "transparent",
   "images" : [
      null
   ],
   "input_fidelity" : "high",
   "mask" : null,
   "model" : "gpt-image-1.5",
   "moderation" : "auto",
   "n" : 1,
   "output_compression" : 100,
   "output_format" : "png",
   "partial_images" : 1,
   "prompt" : "Add a watercolor effect and keep the subject centered",
   "quality" : "high",
   "size" : "1024x1024",
   "stream" : false,
   "user" : "user-1234"
}

Content-Type: multipart/form-data

Example:

{
   "background" : "transparent",
   "image" : "string",
   "input_fidelity" : "high",
   "mask" : "string",
   "model" : "gpt-image-1.5",
   "n" : 1,
   "output_compression" : 100,
   "output_format" : "png",
   "partial_images" : 1,
   "prompt" : "A cute baby sea otter wearing a beret",
   "quality" : "high",
   "response_format" : "url",
   "size" : "1024x1024",
   "stream" : false,
   "user" : "user-1234"
}

Responses

200 - OK

Content-Type: application/json

Example:

{
   "background" : "transparent",
   "created" : 1713833628,
   "data" : [
      {
         "b64_json" : "..."
      }
   ],
   "output_format" : "png",
   "quality" : "high",
   "size" : "1024x1024",
   "usage" : {
      "input_tokens" : 50,
      "input_tokens_details" : {
         "image_tokens" : 40,
         "text_tokens" : 10
      },
      "output_tokens" : 50,
      "total_tokens" : 100
   }
}

Content-Type: text/event-stream

Example:

{
   "b64_json" : "...",
   "background" : "transparent",
   "created_at" : 1620000000,
   "output_format" : "png",
   "partial_image_index" : 0,
   "quality" : "high",
   "size" : "1024x1024",
   "type" : "image_edit.partial_image"
}

SCHEMAS

CreateImageEditRequest

Properties:

  • background (string) - Allows to set transparency for the background of the generated image(s). This parameter is only supported for the GPT image models. Must be one of transparent , opaque or auto (default value). When auto is used, the model will automatically determine the best background for the image.

    If transparent , the output format needs to support transparency, so it should be set to either png (default value) or webp .

    Allowed values: transparent, opaque, auto

    Default: auto

  • image (anyOf, required) - The image(s) to edit. Must be a supported image file or an array of images.

    For the GPT image models (gpt-image-1, gpt-image-1-mini , and gpt-image-1.5 ), each image should be a png , webp , or jpg file less than 50MB. You can provide up to 16 images. chatgpt-image-latest follows the same input constraints as GPT image models.

    For dall-e-2 , you can only provide one image, and it should be a square png file less than 4MB.

  • input_fidelity (anyOf)

  • mask (string) - An additional image whose fully transparent areas (e.g. where alpha is zero) indicate where image should be edited. If there are multiple images provided, the mask will be applied on the first image. Must be a valid PNG file, less than 4MB, and have the same dimensions as image .

  • model (anyOf) - The model to use for image generation. Defaults to gpt-image-1.5 .

    Default: gpt-image-1.5

  • n (integer) - The number of images to generate. Must be between 1 and 10.

    Default: 1

  • output_compression (integer) - The compression level (0-100%) for the generated images. This parameter is only supported for the GPT image models with the webp or jpeg output formats, and defaults to 100.

    Default: 100

  • output_format (string) - The format in which the generated images are returned. This parameter is only supported for the GPT image models. Must be one of png , jpeg , or webp . The default value is png .

    Allowed values: png, jpeg, webp

    Default: png

  • partial_images (PartialImages)

    See "PartialImages" below for shape.

  • prompt (string, required) - A text description of the desired image(s). The maximum length is 1000 characters for dall-e-2 , and 32000 characters for the GPT image models.

  • quality (string) - The quality of the image that will be generated for GPT image models. Defaults to auto .

    Allowed values: standard, low, medium, high, auto

    Default: auto

  • response_format (string) - The format in which the generated images are returned. Must be one of url or b64_json . URLs are only valid for 60 minutes after the image has been generated. This parameter is only supported for dall-e-2 (default is url for dall-e-2 ), as GPT image models always return base64-encoded images.

    Allowed values: url, b64_json

  • size (anyOf) - The size of the generated images. For gpt-image-2 and gpt-image-2-2026-04-21 , arbitrary resolutions are supported as WIDTHxHEIGHT strings, for example 1536x864 . Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above 2560x1440 are experimental, and the maximum supported resolution is 3840x2160 . The requested size must also satisfy the model's current pixel and edge limits. The standard sizes 1024x1024 , 1536x1024 , and 1024x1536 are supported by the GPT image models; auto is supported for models that allow automatic sizing. For dall-e-2 , use one of 256x256 , 512x512 , or 1024x1024 . For dall-e-3 , use one of 1024x1024 , 1792x1024 , or 1024x1792 .

    Default: 1024x1024

  • stream (boolean) - Edit the image in streaming mode. Defaults to false . See the Image generation guide for more information.

    Default:

  • user (string) - A unique identifier representing your end-user, which can help OpenAI to monitor and detect abuse. Learn more .

EditImageBodyJsonParam

Properties:

  • background (anyOf) - Background behavior for generated image output.

    Default: auto

  • images (array of ImageRefParam, required) - Input image references to edit. For GPT image models, you can provide up to 16 images.

  • input_fidelity (anyOf) - Controls fidelity to the original input image(s).

  • mask (ImageRefParam)

    See "ImageRefParam" below for shape.

  • model (anyOf) - The model to use for image editing.

    Default: gpt-image-1.5

  • moderation (anyOf) - Moderation level for GPT image models.

    Default: auto

  • n (anyOf) - The number of edited images to generate.

    Default: 1

  • output_compression (anyOf) - Compression level for jpeg or webp output.

  • output_format (anyOf) - Output image format. Supported for GPT image models.

    Default: png

  • partial_images (PartialImages)

    See "PartialImages" below for shape.

  • prompt (string, required) - A text description of the desired image edit.

  • quality (anyOf) - Output quality for GPT image models.

    Default: auto

  • size (anyOf) - Requested output image size.

    Default: auto

  • stream (anyOf) - Stream partial image results as events.

    Default:

  • user (string) - A unique identifier representing your end-user, which can help OpenAI monitor and detect abuse.

Image

Properties:

  • b64_json (string) - The base64-encoded JSON of the generated image. Returned by default for the GPT image models, and only present if response_format is set to b64_json for dall-e-2 and dall-e-3 .

  • revised_prompt (string) - For dall-e-3 only, the revised prompt that was used to generate the image.

  • url (string) - When using dall-e-2 or dall-e-3 , the URL of the generated image if response_format is set to url (default value). Unsupported for the GPT image models.

ImageEditStreamEvent

See https://platform.openai.com/docs/api-reference for details.

ImageGenInputUsageDetails

Properties:

  • image_tokens (integer, required) - The number of image tokens in the input prompt.

  • text_tokens (integer, required) - The number of text tokens in the input prompt.

ImageGenOutputTokensDetails

Properties:

  • image_tokens (integer, required) - The number of image output tokens generated by the model.

  • text_tokens (integer, required) - The number of text output tokens generated by the model.

ImageGenUsage

Properties:

  • input_tokens (integer, required) - The number of tokens (images and text) in the input prompt.

  • input_tokens_details (ImageGenInputUsageDetails, required)

    See "ImageGenInputUsageDetails" below for shape.

  • output_tokens (integer, required) - The number of output tokens generated by the model.

  • output_tokens_details (ImageGenOutputTokensDetails)

    See "ImageGenOutputTokensDetails" below for shape.

  • total_tokens (integer, required) - The total number of tokens (images and text) used for the image generation.

ImageRefParam

Properties:

  • file_id (string) - The File API ID of an uploaded image to use as input.

  • image_url (string) - A fully qualified URL or base64-encoded data URL.

ImagesResponse

Properties:

  • background (string) - The background parameter used for the image generation. Either transparent or opaque .

    Allowed values: transparent, opaque

  • created (integer, required) - The Unix timestamp (in seconds) of when the image was created.

  • data (array of Image) - The list of generated images.

  • output_format (string) - The output format of the image generation. Either png , webp , or jpeg .

    Allowed values: png, webp, jpeg

  • quality (string) - The quality of the image generated. Either low , medium , or high .

    Allowed values: low, medium, high

  • size (string) - The size of the image generated. Either 1024x1024 , 1024x1536 , or 1536x1024 .

    Allowed values: 1024x1024, 1024x1536, 1536x1024

  • usage (ImageGenUsage)

    See "ImageGenUsage" below for shape.

PartialImages

The number of partial images to generate. This parameter is used for streaming responses that return partial images. Value must be between 0 and 3. When set to 0, the response will be a single image sent in one streaming event.

Note that the final image may be sent before the full number of partial images are generated if the full image is generated more quickly.

SEE ALSO

OpenAPI::Client::OpenAI::Path

COPYRIGHT AND LICENSE

Copyright (C) 2023-2026 by Nelson Ferraz

This library is free software; you can redistribute it and/or modify it under the same terms as Perl itself, either Perl version 5.14.0 or, at your option, any later version of Perl 5 you may have available.